require 'shellwords'
module ArSync
  class TypesGenerator < ::Rails::Generators::Base
    argument :output_dir, type: :string, required: true
    argument :schema_class_name, type: :string, required: false
    def generate_typescript_files
      dir = ::Rails.root.join output_dir
      schema_class = (schema_class_name || 'SyncSchema').constantize
      args = [output_dir, *schema_class_name].map { |a| Shellwords.escape a }
      comment = "// generated by: rails generate ar_sync:types #{args.join(' ')}\n\n"
      ArSync::TypeScript.generate_typed_files schema_class, dir: dir, comment: comment
    end
  end
end
